;ͻ
;                                                                           
;                             bis zu 256 FARBEN mischen RGB                 
;                                                                           
;         (C) Copyright:     Freie Cracker Crew Hamburg Horn                
;                                                                           
;                   von:           Dirk Wolfgang Glomp                      
;                                                                           
;ͼ
.MODEL SMALL
.386
;
  CODE SEGMENT use16 'CODE'
 assume cs:CODE,ds:DATEN,ss:STAPEL
;----------------------------------------------------------------------------
START:    mov     ax, DATEN
          mov     ds, ax
          mov     di, OFFSET FARBE
          mov     es, ax
;
          mov     ah, 62h            ; Segment des PSP's ermitteln
          int   21h
          cli                        ; IRQs verbieten
          mov     ds, bx             ; PSP-Segment nach DS
          mov     si, 80h            ; Zeiger auf Parameter-Anzahl
          mov     al, [si]           ; Anzahl holen
          cmp     al, 7              ;  weniger als  7 ASCII's ?
          jb  FEHLER1                ; zu wenig = Fehler !
          cmp     al, 0Dh            ;  mehr    als 13 ASCII's ?
          ja  FEHLER2                ; zu viel  = Fehler !
          add     si, 2              ; Zeiger auf 1. Parameter
;
          mov     ax, [si]           ; zwei ASCII's holen
          sub     al, 30h            ; 1. ASCII nach Integer wandeln
          add     si, 2              ; Zeiger erhhen
          cmp     al, 9              ;  1. Wert grer als neun ?
          ja  FEHLER3                ; keine Ziffer = Fehler !
          cmp     ah, ","            ;  schon Komma, nur eine Ziffer ?
          jz  short EINER 
          cmp     ah, 0Dh            ;  schon Param.-Ende, nur eine Ziffer ?
          jz  short EINER  
          sub     ah, 30h            ; 2. ASCII nach Integer wandeln
          cmp     ah, 9              ;  2. Wert grer als neun ?
          ja  FEHLER3                ; keine Ziffer = Fehler !
          mov     bl, al             ; 1. Ziffer mal 10
          shl     al, 3              ; Wert mal 8
          xor     dh, dh
          add     bl, bl             ; Wert mal 2
          mov     dl, [si]           ; dritten ASCII holen
          add     al, bl             ; Zehner          = Wert mal 10
          cmp     dl, ","            ;  schon Komma, nur zwei Ziffern ?
          jz  short ZEHNER
          cmp     dl, 0Dh            ;  schon Param.-Ende, nur zwei Ziffern ?
          jz  short ZEHNER
          sub     dl, 30h            ; 3. ASCII nach Integer wandeln
          cmp     dl, 9              ;  3. Wert grer als neun ?
          ja  FEHLER3                ; keine Ziffer = Fehler !
          mov     cx, ax
          inc     si                 ; Zeiger erhhen
          xor     ch, ch
          mov     bx, cx             ; 1. Ziffer noch einmal mal 10
          shl     cx, 3              ; Wert mal 8
          add     bx, bx             ; Wert mal 2
          mov     al, ah             ; 2. Ziffer mal 10
          add     cx, bx             ; jetzt Hunderter = Wert mal 100
          shl     ah, 3              ; Wert mal 8
          add     al, al             ; Wert mal 2
          add     al, ah             ; jetzt Zehner    = Wert mal 10
          xor     ah, ah           
          add     ax, cx             ; Zehner plus Hunderter
          inc     si                 ; Komma berspringen
          add     ax, dx             ; Einer dazu
          jmp  short HUNDERT
;----------------------------------------------------------------------------
 org START + ((($-START)/16)*16)+16  ; Code-Alignment
;----------------------------------------------------------------------------
ZEHNER:   add     al, ah             ; Einer/Zehner dazu
          inc     si                 ; Komma berspringen
EINER:    xor     ah, ah
HUNDERT:  mov     es:[di], al        ; Wert retten
          inc     di                 ; Zeiger erhhen
;----------------------------------------------------------------------------
          mov     cl, 3              ; drei Farb-Anteil-Parameter
HOLWERT:  mov     ax, [si]           ; zwei ASCII's holen
          sub     al, 30h            ; 1. ASCII nach Integer wandeln
          cmp     al, 9              ;  1. Wert grer als neun ?
          ja  FEHLER3                ; keine Ziffer = Fehler !
          add     si, 2              ; Zeiger erhhen
          cmp     ah, 0Dh            ;  Parameter-Ende erreicht ?
          jz  short ANTEIL
          cmp     ah, ","            ;  nur eine Ziffer ?
          jz  short ANTEIL
          sub     ah, 30h            ; 2. ASCII nach Integer wandeln
          cmp     ah, 9              ;  2. Wert grer als neun ?
          ja  short FEHLER3          ; keine Ziffer = Fehler !
;------------------------------------
          mov     bl, al             ; nach zweistelligen Integer wandeln
          shl     al, 3              ; Wert mal 8
          add     bl, bl             ; Wert mal 2
          add     al, bl             ;            = Wert mal 10
          add     al, ah             ; Einer dazu
          inc     si                 ; Komma ueberspringen
;------------------------------------
ANTEIL:   mov     es:[di], al        ; Wert retten
          inc     di
          dec     cl
          jnz HOLWERT
;----------------------------------------------------------------------------
          mov     ax, DATEN
          mov     ds, ax
;------------------------------------
          mov     si, OFFSET FARBE   ; Zeiger auf Farbe
          cmp    BYTE PTR[si+1], 3Fh
          ja  short FEHLER4          ; Rot-Anteil  zu gro = Fehler !
          cmp    BYTE PTR[si+2], 3Fh
          ja  short FEHLER5          ; Grn-Anteil zu gro = Fehler !
          cmp    BYTE PTR[si+3], 3Fh
          ja  short FEHLER6          ; Blau-Anteil zu gro = Fehler !
;------------------------------------
          mov     dx, 3C8h           ; EGA-Farb-Register
          mov     al, [si]           ; Farb-Nr. holen
          out     dx, al             ; und setzen
          inc     dx
          mov     al, [si+1]         ; Rot-Anteil holen
          out     dx, al             ; und setzen
          mov     al, [si+2]         ; Grn-Anteil holen
          out     dx, al             ; und setzen
          mov     al, [si+3]         ; Blau-Anteil holen
          out     dx, al             ; und setzen
;
          xor     al, al             ; kein Fehler
DOS:      mov     ah, 4Ch            ; Dos-Rcksprung
          sti                        ; IRQs erlauben
          int   21h
;
 org START + ((($-START)/16)*16)+16  ; Code-Alignment
;----------------------------------------------------------------------------
FEHLER1:  call BASIS
          mov     al, 1              ; ERRORLEVEL = 1
          mov     dx, OFFSET ERRCO1
;------------------------------------
WORK:     mov     ah, 9              ; Text ausgeben
          int   21h
          jmp  short DOS
;-----------------------------------------------------------------------------
 org START + ((($-START)/16)*16)+16  ; Code-Alignment
;----------------------------------------------------------------------------
FEHLER2:  call BASIS
          mov     al, 2              ; ERRORLEVEL = 2
          mov     dx, OFFSET ERRCO2
          jmp  short WORK
;-----------------------------------------------------------------------------
 org START + ((($-START)/16)*16)+16  ; Code-Alignment
;----------------------------------------------------------------------------
FEHLER3:  call BASIS
          mov     al, 3              ; ERRORLEVEL = 3
          mov     dx, OFFSET ERRCO3
          jmp  short WORK
;-----------------------------------------------------------------------------
 org START + ((($-START)/16)*16)+16  ; Code-Alignment
;----------------------------------------------------------------------------
FEHLER4:  call BASIS
          mov     al, 4              ; ERRORLEVEL = 4
          mov     dx, OFFSET ERRCO4
          jmp  short WORK
;-----------------------------------------------------------------------------
 org START + ((($-START)/16)*16)+16  ; Code-Alignment
;----------------------------------------------------------------------------
FEHLER5:  call BASIS
          mov     al, 5              ; ERRORLEVEL = 5
          mov     dx, OFFSET ERRCO5
          jmp  short WORK
;-----------------------------------------------------------------------------
 org START + ((($-START)/16)*16)+16  ; Code-Alignment
;----------------------------------------------------------------------------
FEHLER6:  call BASIS
          mov     al, 6              ; ERRORLEVEL = 6
          mov     dx, OFFSET ERRCO6
          jmp  short WORK
;
;                        U n t e r  -  P r o g r a m m e
;
 org START + ((($-START)/16)*16)+16  ; Code-Alignment
;----------------------------------------------------------------------------
BASIS:    mov     ax, DATEN
          mov     ds, ax
          mov     dx, OFFSET SYNTAX
          mov     ah, 9
          int   21h
          ret
;----------------------------------------------------------------------------
  CODE ends
;
;                          D A T E N - B E R E I C H
;
  DATEN SEGMENT use32 'DATA'         ; Daten-Alignment
;----------------------------------------------------------------------------
FARBE     DB ?, ?, ?, ?
;----------------------------------------------------------------------------
SYNTAX    DB 0Dh, 0Ah
DB "ͻ"
DB "                                                                              "
DB "     SYNTAX:    FARBTEIL.exe Farb-Nummer,Rot-Anteil,Grn-Anteil,Blau-Anteil   "
DB "                                                                        "
DB "                4 Parameter; Leerzeichen hinter Kommas, sind nicht erlaubt !  "
DB "                                                                              "
DB "                                                         Farb-Nr. Farb-Name  "
DB "   FARBANTEILE     1. Farb-Nummer:  von  0  bis  255       "
DB "                                                  0     schwarz   "
DB "     SETZEN        2. Rot- Anteil:  von  0  bis   63         1     blau      "
DB "                                                       2     grn      "
DB "      RGB          3. Grn-Anteil:  von  0  bis   63         3     cyan      "
DB "                                                          4     rot       "
DB "                   4. Blau-Anteil:  von  0  bis   63         5     magenta   "
DB "   Version   1.0                                             6     braun     "
DB "  _  _  _  _  _  _  _  _  _  _  _  _  _  _  _  _  _          7     wei      "
DB "                                                                              "
DB "  (C) Copyright:    Freie Cracker Crew Hamburg Horn       fr Text und Grafik "
DB "                                                                              "
DB "            von:           Dirk Wolfgang Glomp             Farben 16 oder 256 "
DB "                                                                              "
DB "ͼ"
DB 0Dh, 0Ah ,"$"
;----------------------------------------------------------------------------
ERRCO1    DB "                   zu wenige Parameter angegeben = Fehler !"
          DB 7, "$"
ERRCO2    DB "                   zu viele Parameter angegeben = Fehler !"
          DB 7, "$"
ERRCO3    DB "                   keine Ziffer = Fehler !"
          DB 7, "$"
ERRCO4    DB "                   Rot-Anteil  zu hoch = Fehler !"
          DB 7, "$"
ERRCO5    DB "                   Grn-Anteil zu hoch = Fehler !"
          DB 7, "$"
ERRCO6    DB "                   Blau-Anteil zu hoch = Fehler !"
          DB 7, "$"
;----------------------------------------------------------------------------
  DATEN ends
;
  STAPEL SEGMENT use16 STACK 'STACK'
          DB 10h dup (?)
  STAPEL ends
;
 end
