;ͻ
;                                                                           
;          (C) Copyright:  Freie Cracker Crew Hamburg Horn                  
;                                                                           
;                    von:        Dirk Wolfgang Glomp                        
;                                                                           
;ͼ
.MODEL SMALL
.386P
.387
;
                Z  =  320             ; Lnge einer Bildschirm-Zeile
;
  CODE SEGMENT use16 'CODE'
 assume cs:CODE,ds:DATEN,ss:STAPEL
;----------------------------------------------------------------------------
START:    mov     ax, DATEN
          mov     ds, ax
          mov     di, OFFSET XM       ; Offset der zu rettenden Werte
          mov     es, ax
;
          mov     ah, 62h             ; Segment des PSP's ermitteln
          int   21h
          cli                         ; IRQs verbieten
          mov     ds, bx              ; PSP-Segment nach DS
          mov     si, 80h             ; Zeiger auf Parameter
          mov     al, [si]
          cmp     al, 9               ;  weniger als  5 ASCII's ?
          jb  FEHLER1                 ; zu wenig = Fehler !
          cmp     al, 14h             ;  mehr    als 20 ASCII's ?
          ja  FEHLER2                 ; zu viel  = Fehler !
          add     si, 2
;
; Holt ASCII-Ziffer bis zum Komma, wandelt max. 3 Ziffern und rettet Word-Wert
;
          mov     bp, 4               ; fnf Parameter
;-------------------------------------
HOLWERT:  mov     ax, [si]            ; zwei ASCII's holen
          sub     al, 30h             ; 1. ASCII nach Integer wandeln
          add     si, 2               ; Zeiger erhhen
          cmp     al, 9               ;  1. Wert grer als neun ?
          ja  FEHLER3                 ; keine Ziffer = Fehler !
          cmp     ah, ","             ;  schon Komma, nur eine Ziffer ?
          jz  short EINER
          cmp     ah, 0Dh             ;  schon Param.-Ende, nur eine Ziffer ?
          jz  short EINER
          sub     ah, 30h             ; 2. ASCII nach Integer wandeln
          cmp     ah, 9               ;  2. Wert grer als neun ?
          ja  FEHLER3                 ; keine Ziffer = Fehler !
          mov     bl, al              ; 1. Ziffer mal 10
          shl     al, 3               ; Wert mal 8
          xor     dh, dh
          add     bl, bl              ; Wert mal 2
          mov     dl, [si]            ; dritten ASCII holen
          add     al, bl              ; Zehner          = Wert mal 10
          cmp     dl, ","             ;  schon Komma, nur zwei Ziffern ?
          jz  short ZEHNER
          cmp     dl, 0Dh             ;  schon Param.-Ende, nur zwei Ziffern ?
          jz  short ZEHNER
          sub     dl, 30h             ; 3. ASCII nach Integer wandeln
          cmp     dl, 9               ;  3. Wert grer als neun ?
          ja  FEHLER3                 ; keine Ziffer = Fehler !
          mov     cx, ax
          inc     si                  ; Zeiger erhhen
          xor     ch, ch
          mov     bx, cx              ; 1. Ziffer noch einmal mal 10
          shl     cx, 3               ; Wert mal 8
          add     bx, bx              ; Wert mal 2
          mov     al, ah              ; 2. Ziffer mal 10
          add     cx, bx              ; jetzt Hunderter = Wert mal 100
          shl     ah, 3               ; Wert mal 8
          add     al, al              ; Wert mal 2
          add     al, ah              ; jetzt Zehner    = Wert mal 10
          xor     ah, ah
          add     ax, cx              ; Zehner plus Hunderter
          inc     si                  ; Komma berspringen
          add     ax, dx              ; Einer dazu
          jmp  short HUNDERT
;-------------------------------------
 org START + ((($-START)/16)*16)+16   ; Code-Alignment
;-------------------------------------
ZEHNER:   add     al, ah              ; Einer/Zehner dazu
          inc     si                  ; Komma berspringen
EINER:    xor     ah, ah
HUNDERT:  mov     es:[di], ax         ; Wert retten
          add     di, 2               ; Zeiger erhhen
          dec     bp
          jnz HOLWERT
;
          mov     ax, DATEN
          mov     bx, 0A000h          ; Grafik-Bildschirm-Segment
          mov     ds, ax
          mov     fs, bx
;-------------------------------------
          cmp     XM, 319             ; X-Mittelpunkt
          ja  FEHLER4                 ;  Wert zu gro = Fehler !
          cmp     YM, 199             ; Y-Mittelpunkt
          ja  FEHLER5                 ;  Wert zu gro = Fehler !
          mov     cx, RADIUS          ; Radius holen
          cmp     cx, 255             ;  Wert zu gro = Fehler !
          ja  FEHLER6
          mov     bx, FARBE           ; Farbe holen
          cmp     bx, 255             ;  Wert zu gro = Fehler !
          ja  FEHLER7
;
          mov     bh, bl
          mov     si, XM
          mov     di, YM
          mov    WORD PTR cs:[COLOR+3], bx  ; Farbe
          mov     dr0, si
          mov     dr1, di
;
;                       K r e i s  -  R O U T I N E
;
          xor     di, di              ; Schleifen-Anfang
;-------------------------------------
RUNDE:    mov     ax, cx
          xor     dx, dx
          mul     ax                  ; Radius * Radius
          xor     dx, dx
          mov     bp, ax
          mov     ax, di
          mov     Y, bp
          mul     ax                  ; X * X
          sub     Y, ax               ; R * R - X * X
;------------------
          fild    Y                   ; Integer nach ST(0) laden
          fsqrt                       ; Wurzel ziehen
          fistp  DWORD PTR[Y]         ; Ergebnis (Integer) speichern und pop
          inc     di                  ; Schleifen-Zhler erhhen
          mov     ax, Y
;------------------
          call HALB                   ; 4 Pixel setzen
          mov     bx, ax
          mov     ax, di              ; X mit Y vertauschen, nchste Achse
          mov     di, bx
          call HALB                   ; 4 Pixel setzen
          mov     di, ax              ; X wieder restaurieren
          cmp     di, cx              ; Radiant erreicht ?
          jnz RUNDE
;
          xor     al, al              ; kein Fehler
DOS:      mov     ah, 4Ch             ; Dos-Rcksprung
          sti
          int   21h
;
 org START + ((($-START)/16)*16)+16   ; Code-Alignment
;----------------------------------------------------------------------------
FEHLER1:  call BASIS
          mov     al, 1               ; ERRORLEVEL = 1
          mov     dx, OFFSET ERRCO1
;-------------------------------------
WORK:     mov     ah, 9               ; Text ausgeben
          int   21h
          jmp  short DOS
;----------------------------------------------------------------------------
 org START + ((($-START)/16)*16)+16   ; Code-Alignment
;----------------------------------------------------------------------------
FEHLER2:  call BASIS
          mov     al, 2               ; ERRORLEVEL = 2
          mov     dx, OFFSET ERRCO2
          jmp  short WORK
;----------------------------------------------------------------------------
 org START + ((($-START)/16)*16)+16   ; Code-Alignment
;----------------------------------------------------------------------------
FEHLER3:  call BASIS
          mov     al, 3               ; ERRORLEVEL = 3
          mov     dx, OFFSET ERRCO3
          jmp  short WORK
;----------------------------------------------------------------------------
 org START + ((($-START)/16)*16)+16   ; Code-Alignment
;----------------------------------------------------------------------------
FEHLER4:  call BASIS
          mov     al, 4               ; ERRORLEVEL = 4
          mov     dx, OFFSET ERRCO4
          jmp  short WORK
;----------------------------------------------------------------------------
 org START + ((($-START)/16)*16)+16   ; Code-Alignment
;----------------------------------------------------------------------------
FEHLER5:  call BASIS
          mov     al, 5               ; ERRORLEVEL = 5
          mov     dx, OFFSET ERRCO5
          jmp  short WORK
;----------------------------------------------------------------------------
 org START + ((($-START)/16)*16)+16   ; Code-Alignment
;----------------------------------------------------------------------------
FEHLER6:  call BASIS
          mov     al, 6               ; ERRORLEVEL = 6
          mov     dx, OFFSET ERRCO6
          jmp  short WORK
;----------------------------------------------------------------------------
 org START + ((($-START)/16)*16)+16   ; Code-Alignment
;----------------------------------------------------------------------------
FEHLER7:  call BASIS
          mov     al, 7               ; ERRORLEVEL = 7
          mov     dx, OFFSET ERRCO7
          jmp  short WORK
;
;                        U n t e r  -  P r o g r a m m e
;
 org START + ((($-START)/16)*16)+16   ; Code-Alignment
;----------------------------------------------------------------------------
BASIS:    mov     ax, DATEN
          mov     ds, ax
          mov     dx, OFFSET SYNTAX
          mov     ah, 9
          int   21h
          ret
;
 org START + ((($-START)/16)*16)+16   ; Code-Alignment
;----------------------------------------------------------------------------
HALB:     mov     bx, dr1             ; Y-Mittelpunkt
          mov     si, dr0             ; X-Mittelpunkt
          add     bx, ax              
          add     si, di              
          sub     bx, 3
          call  PIXEL                 ; unten rechts
;-------------------------------------
          mov     bx, dr1             ; Y-Mittelpunkt
          mov     si, dr0             ; X-Mittelpunkt
          add     bx, ax              
          sub     si, di
          sub     bx, 3
          call  PIXEL                 ; unten links
;-------------------------------------
          mov     bx, dr1             ; Y-Mittelpunkt
          mov     si, dr0             ; X-Mittelpunkt
          sub     bx, ax
          add     si, di              
          add     bx, 2
          call  PIXEL                 ; oben rechts
;-------------------------------------
          mov     bx, dr1             ; Y-Mittelpunkt
          mov     si, dr0             ; X-Mittelpunkt
          sub     bx, ax
          sub     si, di
          add     bx, 2               ; oben links
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
PIXEL:    add     bx, bx              ; Y holen
          mov     bx, [bx]            ; Zeile aus Zeilen-Tabelle
COLOR:    mov    WORD PTR fs:[bx+si], 0 ; (Farb-Dummy) zwei Pixel schreiben
          ret
;----------------------------------------------------------------------------
  CODE ends
;
;                          D A T E N - B E R E I C H
;
  DATEN SEGMENT use32 'DATA'          ; Daten-Alignment
;----------------------------------------------------------------------------
PIXTAB    DW 000h*Z, 001h*Z, 002h*Z, 003h*Z, 004h*Z, 005h*Z, 006h*Z, 007h*Z
          DW 008h*Z, 009h*Z, 00Ah*Z, 00Bh*Z, 00Ch*Z, 00Dh*Z, 00Eh*Z, 00Fh*Z
          DW 010h*Z, 011h*Z, 012h*Z, 013h*Z, 014h*Z, 015h*Z, 016h*Z, 017h*Z
          DW 018h*Z, 019h*Z, 01Ah*Z, 01Bh*Z, 01Ch*Z, 01Dh*Z, 01Eh*Z, 01Fh*Z
          DW 020h*Z, 021h*Z, 022h*Z, 023h*Z, 024h*Z, 025h*Z, 026h*Z, 027h*Z
          DW 028h*Z, 029h*Z, 02Ah*Z, 02Bh*Z, 02Ch*Z, 02Dh*Z, 02Eh*Z, 02Fh*Z
          DW 030h*Z, 031h*Z, 032h*Z, 033h*Z, 034h*Z, 035h*Z, 036h*Z, 037h*Z
          DW 038h*Z, 039h*Z, 03Ah*Z, 03Bh*Z, 03Ch*Z, 03Dh*Z, 03Eh*Z, 03Fh*Z
          DW 040h*Z, 041h*Z, 042h*Z, 043h*Z, 044h*Z, 045h*Z, 046h*Z, 047h*Z
          DW 048h*Z, 049h*Z, 04Ah*Z, 04Bh*Z, 04Ch*Z, 04Dh*Z, 04Eh*Z, 04Fh*Z
          DW 050h*Z, 051h*Z, 052h*Z, 053h*Z, 054h*Z, 055h*Z, 056h*Z, 057h*Z
          DW 058h*Z, 059h*Z, 05Ah*Z, 05Bh*Z, 05Ch*Z, 05Dh*Z, 05Eh*Z, 05Fh*Z
          DW 060h*Z, 061h*Z, 062h*Z, 063h*Z, 064h*Z, 065h*Z, 066h*Z, 067h*Z
          DW 068h*Z, 069h*Z, 06Ah*Z, 06Bh*Z, 06Ch*Z, 06Dh*Z, 06Eh*Z, 06Fh*Z
          DW 070h*Z, 071h*Z, 072h*Z, 073h*Z, 074h*Z, 075h*Z, 076h*Z, 077h*Z
          DW 078h*Z, 079h*Z, 07Ah*Z, 07Bh*Z, 07Ch*Z, 07Dh*Z, 07Eh*Z, 07Fh*Z
          DW 080h*Z, 081h*Z, 082h*Z, 083h*Z, 084h*Z, 085h*Z, 086h*Z, 087h*Z
          DW 088h*Z, 089h*Z, 08Ah*Z, 08Bh*Z, 08Ch*Z, 08Dh*Z, 08Eh*Z, 08Fh*Z
          DW 090h*Z, 091h*Z, 092h*Z, 093h*Z, 094h*Z, 095h*Z, 096h*Z, 097h*Z
          DW 098h*Z, 099h*Z, 09Ah*Z, 09Bh*Z, 09Ch*Z, 09Dh*Z, 09Eh*Z, 09Fh*Z
          DW 0A0h*Z, 0A1h*Z, 0A2h*Z, 0A3h*Z, 0A4h*Z, 0A5h*Z, 0A6h*Z, 0A7h*Z
          DW 0A8h*Z, 0A9h*Z, 0AAh*Z, 0ABh*Z, 0ACh*Z, 0ADh*Z, 0AEh*Z, 0AFh*Z
          DW 0B0h*Z, 0B1h*Z, 0B2h*Z, 0B3h*Z, 0B4h*Z, 0B5h*Z, 0B6h*Z, 0B7h*Z
          DW 0B8h*Z, 0B9h*Z, 0BAh*Z, 0BBh*Z, 0BCh*Z, 0BDh*Z, 0BEh*Z, 0BFh*Z
          DW 0C0h*Z, 0C1h*Z, 0C2h*Z, 0C3h*Z, 0C4h*Z, 0C5h*Z, 0C6h*Z, 0C7h*Z
;----------------------------------------------------------------------------
XM        DW ?                        ; X-Kreis-Mittelpunkt
YM        DW ?                        ; Y-Kreis-Mittelpunkt
RADIUS    DW ?                        ; Radius
FARBE     DW ?                        ; Farbe
Y         DW ?, ?                     ; FPU 32 Bit-Zugriff
;----------------------------------------------------------------------------
SYNTAX    DB 0Dh, 0Ah
DB "ͻ"
DB "                                                                              "
DB "           SYNTAX:  MCGAKREI.exe X-Mittelpunkt,Y-Mittelpunkt,Radius,Farbe     "
DB "                                                                              "
DB " Ŀ      X-Mittelpunkt    :  von  0  bis  319             "
DB "         KREIS                                                              "
DB "                           Y-Mittelpunkt    :  von  0  bis  199             "
DB "  fr GRAFIK-MODE: 19                                                       "
DB "       Radius           :  von  0  bis  255             "
DB "                                                                              "
DB "      4 Parameter            Farbe            :  von  0  bis  255             "
DB "                                                                              "
DB "    (C) Copyright:              Freie Cracker Crew Hamburg Horn               "
DB "                                                                  Version 1.0 "
DB "              von:                    Dirk Wolfgang Glomp                     "
DB "                                                                              "
DB "ͼ"
DB "$"
;-----------------------------------------------------------------------------
ERRCO1    DB "                   zu wenige Parameter angegeben = Fehler !"
          DB 7, "$"
ERRCO2    DB "                   zu viele Parameter angegeben = Fehler !"
          DB 7, "$"
ERRCO3    DB "                   keine Ziffer = Fehler !"
          DB 7, "$"
ERRCO4    DB "                   X-Wert zu hoch = Fehler !"
          DB 7, "$"
ERRCO5    DB "                   Y-Wert zu hoch = Fehler !"
          DB 7, "$"
ERRCO6    DB "                   Radius zu hoch = Fehler !"
          DB 7, "$"
ERRCO7    DB "                   Farb-Nr. zu hoch = Fehler !"
          DB 7, "$"
;----------------------------------------------------------------------------
  DATEN ends
;
  STAPEL SEGMENT use16 STACK 'STACK'
          DB 10h dup (?)
  STAPEL ends
;
 end
